datablock TSShapeConstructor(AlligatorDts)
{
	baseShape  = "./Alligator.dts";
	sequence0  = "./GATOR_root.dsq root";

	sequence1  = "./GATOR_run.dsq run";
	sequence2  = "./GATOR_run.dsq walk";
	sequence3  = "./GATOR_run.dsq back";
	sequence4  = "./GATOR_side.dsq side";

	sequence5  = "./GATOR_crouch.dsq crouch";
	sequence6  = "./GATOR_crouchRun.dsq crouchRun";
	sequence7  = "./GATOR_crouchRun.dsq crouchBack";
	sequence8  = "./GATOR_crouchRun.dsq crouchSide";

	sequence9  = "./GATOR_root.dsq look";
	sequence10 = "./GATOR_root.dsq headside";
	sequence11 = "./GATOR_root.dsq headUp";

	sequence12 = "./GATOR_jump.dsq jump";
	sequence13 = "./GATOR_jump.dsq standjump";
	sequence14 = "./GATOR_jump.dsq fall";
	sequence15 = "./GATOR_jump.dsq land";

	sequence16 = "./GATOR_ArmAttack.dsq armAttack";
	sequence17 = "./GATOR_ArmReady.dsq armReadyLeft";
	sequence18 = "./GATOR_ArmReady.dsq armReadyRight";
	sequence19 = "./GATOR_ArmReady.dsq armReadyBoth";
	sequence20 = "./GATOR_root.dsq spearready";  
	sequence21 = "./GATOR_root.dsq spearThrow";

	sequence22 = "./GATOR_talk.dsq talk";  

	sequence23 = "./GATOR_death.dsq death1"; 
	
	sequence24 = "./GATOR_root.dsq shiftUp";
	sequence25 = "./GATOR_root.dsq shiftDown";
	sequence26 = "./GATOR_root.dsq shiftAway";
	sequence27 = "./GATOR_root.dsq shiftTo";
	sequence28 = "./GATOR_root.dsq shiftLeft";
	sequence29 = "./GATOR_root.dsq shiftRight";
	sequence30 = "./GATOR_root.dsq rotCW";
	sequence31 = "./GATOR_root.dsq rotCCW";

	sequence32 = "./GATOR_root.dsq undo";
	sequence33 = "./GATOR_root.dsq plant";

	sequence34 = "./GATOR_sit.dsq sit";

	sequence35 = "./GATOR_wrench.dsq wrench";

   sequence36 = "./GATOR_activate.dsq activate";
   sequence37 = "./GATOR_activate.dsq activate2";

   sequence38 = "./GATOR_root.dsq leftrecoil";
};  

datablock fxDTSBrickData (BrickAlligatorBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/8xspawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "Alligator Hole";
	iconName = "Add-Ons/Bot_Alligator/icon_Alligator";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "AlligatorHoleBot";
};

// when the Alligator brick is initially planted hide it, as most of the time we don't want it to exist since we're in the water
function BrickAlligatorBot_HoleSpawnData::onPlant( %this, %obj )
{
	%obj.setRendering(0);
	%obj.setColliding(0);
	%obj.setRaycasting(0);
}

//Alligator melee icon
AddDamageType("AlligatorHoleBite",   '<bitmap:Add-Ons/Bot_Alligator/CI_Alligator> %1',    '%2 <bitmap:Add-Ons/Bot_Alligator/CI_Alligator> %1',0.5,1);


datablock PlayerData(AlligatorHoleBot : PlayerStandardArmor)
{
	shapeFile = "./Alligator.dts";
	uiName = "Alligator";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;
	maxWeapons = 5;
	maxTools = 5;

	rideable = false;
	canRide = false;
	paintable = false;

	mass = 120;
	drag = 0.06;//0.02
	density = 0.80;//0.6
	runSurfaceAngle = 85;
	jumpSurfaceAngle = 86;
	maxForwardSpeed = 5;
	maxBackwardSpeed = 2;
	maxBackwardCrouchSpeed = 1;
	maxForwardCrouchSpeed = 2;
	maxSideSpeed = 2;
	maxSideCrouchSpeed = 2;
	maxStepHeight = 1;
    maxUnderwaterSideSpeed = 0;
	maxUnderwaterForwardSpeed = 0;
	maxUnderwaterBackwardSpeed = 0;
	showEnergyBar = false;
	

	jumpForce = 0.1;
	upMaxSpeed = 7;
	upResistFactor = 0.5;

	minJumpSpeed = 0;
	maxJumpSpeed = 0.25;

	boundingBox			= vectorScale("1.75 1.75 1.35", 3); //"2.5 2.5 2.4";
	crouchBoundingBox	= vectorScale("1.75 1.75 1.35", 3); //"2.5 2.5 2.4";
	proneBoundingBox	= vectorScale("1.75 1.75 1.35", 3); //"2.5 2.5 2.4";

	maxdamage = 300;//Bot Health
	jumpSound = "";//Removed due to bots jumping a lot
	
	//Hole Attributes
	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Alligator; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 70;
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "Alligator";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 16;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 0;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	hFOVRange = 0.7;
	  hFOVRadius = 5;//max 10
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 0;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 1;//Melee
	  hAttackDamage = 30;//Melee Damage
	  hMeleeCI = "AlligatorHoleBite";
	hShoot = 0;
	  hWep = "gunImage";
	  hShootTimes = 4;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 256;//The range in which the bot will shoot the player
	  hAvoidCloseRange = 1;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hAvoidObstacles = 1;
	hSuperStacker = 0;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 1;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 1;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 1;
};

function AlligatorHoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);
	%obj.hIsAlligator = 1;
	%color[%a++] = "0.00 0.50 0.25 1";
	%color[%a++] = "0.15 0.35 0.25 1";
	%color[%a++] = "0.13 0.27 0.27 1";
	%color[%a++] = "0.15 0.45 0.35 1";
	%color[%a++] = "0.30 0.60 0.35 1";

	%choice = getRandom(1,%a);
	%obj.setNodeColor("ALL",%color[%choice]);
	%obj.chestColor =  %color[%choice];
	scheduleNoQuota(10,%obj,delayGatorCheck,%obj);

	// %obj.invulnerable = 1;
	
	// if( isObject(%obj.spawnBrick) )
	// {
		// %obj.spawnBrick.setRendering(0);
		// %obj.spawnBrick.setColliding(0);
		// %obj.spawnBrick.setRaycasting(0);
	// }
}

function delayGatorCheck(%obj)
{
	if(isObject(%obj))
	{
		if(!getRandom(0,1000) || %obj.name $= "Albino Alligator")
		{
			%obj.setNodeColor("ALL","1.0 0.95 0.94 1.0");
			%obj.chestColor =  "1.0 0.95 0.94 1.0";
			%obj.hIsAlbino = 1;
			%obj.hSearchRadius = 8;//in brick units
			%obj.hNeutralAttackChance = 30;
			%obj.hSpawnDist = 96;
			%obj.name = "Albino Alligator";
		}
	}
}

function AlligatorHoleBot::onEnterLiquid(%data, %obj, %coverage, %type)
{
	// do nothing, hack for now to prevent Alligators from being auto killed by water
	%obj.hFishOutOfWater = 0;
}

function AlligatorHoleBot::onNewDataBlock(%this,%obj)
{
	%color[%a++] = "0.00 0.50 0.25 1";
	%color[%a++] = "0.15 0.35 0.25 1";
	%color[%a++] = "0.13 0.27 0.27 1";
	%color[%a++] = "0.15 0.45 0.35 1";
	%color[%a++] = "0.30 0.60 0.35 1";

	%obj.setNodeColor("ALL",%color[getRandom(1,%a)]);
}
function AlligatorHoleBot::onBotLoop(%this,%obj)
{
	//Check if he's in water if he is play the swim animation
	if( isObject(%obj) && !%obj.getObjectMount() && !%obj.isDisabled() )//%obj.getState !$= "Dead")
	{
		if(%obj.getWaterCoverage() && !%obj.isSwimming)
		{
			%obj.playThread(0,CrouchRun);
			%obj.isSwimming = 1;
		}
		else if( !%obj.getWaterCoverage() && %obj.isSwimming )
		{
			%obj.playThread(0,run);
			%obj.isSwimming = 0;
		}
	}
	else if(!%obj.getObjectMount())
		%obj.playThread(0,root);

}

function AlligatorHoleBot::onBotCollision( %this, %obj, %col, %normal, %speed )
{
	 if( %obj.isDisabled() )
		return;

	%canDamage = miniGameCanDamage(%obj,%col);
		
	if( isObject(%obj.hEating) || %obj.getMountedObject( 0 ) || %col.isDisabled() || %canDamage == 0 || %canDamage == -1 ) // !checkHoleBotTeams(%obj,%col) ||
		return;
		
	//Check if we can attack, then check if it's a minifig, then eat him//%col.isHoleBot &&
	%oScale = getWord(%obj.getScale(),0);
	%cScale = getWord(%col.getScale(),0);
	// if( (!getRandom(0,1)|| %obj.hIsAlbino) && %obj.getState() !$= "Dead" && checkHoleBotTeams(%obj,%col) && !isObject(%obj.hEating) && %col.getState() !$= "Dead" && miniGameCanDamage(%obj,%col) == 1)
	
	// if we collide with a vehicle then eject the player
	// this may cause some funky things, but it should be entertaining
	%wasEjected = 0;
	
	// %checkTeam = checkHoleBotTeams(%obj,%col);
	
	if( %col.getMountedObjectCount() && ( !getRandom( 0, 2 ) || %obj.hIsAlbino || ( %col.getType() & $TypeMasks::VehicleObjectType ) ) )
	{
		if( %col.hIsAlligator && %col.getMountedObject( 0 ).hIsAlligator )
			return;
	
		%col = %col.ejectRandomPlayer();
		%wasEjected = 1;
		
		if( %col.client )
			%col.client.setControlObject( %col );
	}
	
	%checkTeam = checkHoleBotTeams(%obj,%col);
	
	if( ( !getRandom(0,2)|| %obj.hIsAlbino || %wasEjected ) && %checkTeam )
	{
		if(  %oScale+0.5 >= %cScale && %col.getDataBlock().shapeFile $= "base/data/shapes/player/m.dts")
		{
			if(%col.getClassName() $= "Player" && %col.client)
			{
				%col.client.camera.setOrbitMode(%obj, %obj.getTransform(), 0, 10, 0, 1);
				%col.client.setControlObject(%col.client.camera);
				//hSpazzClick(%col,0,1);
			}
			%obj.stopHoleLoop();
			%obj.hRunAwayFromPlayer(%col);
			// %obj.setImageTrigger(3,1);
			%obj.setCrouching(1);
			%obj.mountObject(%col,2);
			
			%obj.hIgnore = %col;
			%obj.hEating = %col;
			%obj.hLastEatTime = getSimTime();
			
			// temporarily set the Alligator to invulnerable when he eats someone to avoid getting
			%obj.invulnerable = true;
			schedule( 200, %obj, eval, %obj @ ".invulnerable = false;" );

			%obj.hAlligatorEatDelay = scheduleNoQuota(5000,0,holeAlligatorKill,%obj,%col);
			return;
		}	
		if(  %oScale >= %cScale+0.5 && %col.getDataBlock().shapeFile $= "Add-Ons/Bot_Alligator/Alligator.dts")
		{
			if(%col.getClassName() $= "Player" && %col.client)
			{
				%col.client.camera.setOrbitMode(%obj, %obj.getTransform(), 0, 10, 0, 1);
				%col.client.setControlObject(%col.client.camera);
				//hSpazzClick(%col,0,1);
			}
			%obj.stopHoleLoop();
			%obj.hRunAwayFromPlayer(%col);
			%obj.mountObject(%col,3);

			%obj.playThread(1,ArmReady);
			%col.playThread(0,wrench);
			%obj.hIgnore = %col;
			%obj.hEating = %col;
			%obj.hLastEatTime = getSimTime();
			
			%obj.invulnerable = true;
			schedule( 200, %obj, eval, %obj @ ".invulnerable = false;" );
			
			%obj.hAlligatorEatDelay = scheduleNoQuota(5000,0,holeAlligatorKill,%obj,%col);
			return;
		}
	}
	
	if( %checkTeam )
	{
		%obj.hAttackDamage = 35;
		%obj.hMeleeAttack( %col );
		%obj.hAttackDamage = 0;
	}
}

function holeAlligatorKill(%obj,%col)
{
	if( !isObject(%obj) || %obj.isDisabled() )
		return;
		
	// we can no longer damage the guy release him
	if( miniGameCanDamage( %obj, %col ) != 1 )
	{
		%col.disMount();
		
		if( %col.client )
			%col.client.setControlObject( %col );
		
		return;
	}
		
	if(%obj.getMountedObject(0) == %col)
	{
		if(%col.getClassName() $= "Player" )
		{
			%col.damage(%obj.hFakeProjectile, %col.getposition(), 1000, $DamageType::AlligatorHoleBite);
		}
		else
		{
			if(%obj.hIsInfected && getRandom(0,2))
			{
				holeZombieInfect(%obj,%col);
				%col.dismount();
				%col.playThread(0,root);
				%obj.playThread(1,root);
				%obj.hIgnore = 0;
				%obj.hEating = 0;
			}
			else
			{
				%col.kill();
				%obj.playThread(1,root);
				%obj.hEating = 0;
			}
		}
	}
	%obj.startHoleLoop();
}

function AlligatorHoleBot::onRemove(%this,%obj)
{
	if( isObject( (%col = %obj.hEating) ) )
	{
		%col.playThread(0,root);
		if(%col.getClassName() $= "Player" && !%col.getControllingClient())
		{
			//cancel(%col.hSpazzClick);
			if( isObject(%col.client) )
				%col.client.setControlObject(%col);
		}
	}
}

function AlligatorHoleBot::onBotFollow(%this,%obj,%targ)
{
	//Called when the target follows a player each tick, or is running away
}

function AlligatorHoleBot::onDisabled(%this,%obj,%a)
{
	if( isObject(%obj.hEating) && %obj.hEating == %obj.getMountedObject(0) )
	{
		cancel(%obj.hAlligatorEatDelay);
		%targ = %obj.hEating;
		
		%obj.hEating = 0;
		%targ.dismount();
		%targ.playThread(0,root);
		//%obj.playThread(1,root);
		if(%targ.getClassName() $= "Player")
		{
			//cancel(%targ.hSpazzClick);
			if( isObject(%targ.client) )
				%targ.client.setControlObject(%targ);
		}
	}
	%obj.playThread(0,root);
	parent::onDisabled(%this,%obj,%a);
}

function AlligatorHoleBot::onBotDamage(%this,%obj,%source,%pos,%damage,%type)
{
	if( %obj.hLastEatTime+200 > getSimTime() )
		return;

	//If the Alligator has a bot in his mouth and he gets hurt randomly dismount the bot
	if( (!getRandom(0,3) || %damage >= 50 ) && isObject(%obj.hEating) && %obj.hEating == %obj.getMountedObject(0) )
	{
		cancel(%obj.hAlligatorEatDelay);
		%targ = %obj.hEating;

		%obj.hEating = 0;
		%targ.dismount();
		%targ.playThread(0,root);
		%obj.playThread(1,root);
		%obj.hIgnore = 0;
		if(%targ.getClassName() $= "Player")
		{
			//cancel(%targ.hSpazzClick);
			%targ.client.setControlObject(%targ);
		}
		
		%obj.lastattacked = getsimtime()+1000;

		%obj.hRunAwayFromPlayer(%targ);
		%obj.scheduleNoQuota(2000,startHoleLoop);
	}
}

package holeAlligatorPackage
{
	function Observer::onTrigger(%this, %obj, %a, %b)
	{
		%client = %obj.getControllingClient();

		if( isObject(%client.player) && %client.player.getObjectMount().hIsAlligator )
		{
			if( %b )
				%client.player.activateStuff();
				
			return;
		}

		parent::onTrigger(%this, %obj, %a, %b);
	}
};
activatePackage(holeAlligatorPackage);